/*
 * @author electricessence / https://github.com/electricessence/
 * Based Upon: http://referencesource.microsoft.com/#System/CompMod/system/collections/generic/queue.cs
 * Licensing: MIT https://github.com/electricessence/TypeScript.NET/blob/master/LICENSE.md
 */
!function(e){if("object"==typeof module&&"object"==typeof module.exports){var t=e(require,exports);void 0!==t&&(module.exports=t)}else"function"==typeof define&&define.amd&&define(["require","exports","../Compare","./Array/Utility","../Types","../Integer","./Enumeration/EnumeratorBase","../Exceptions/NotImplementedException","../Exceptions/InvalidOperationException","../Exceptions/ArgumentOutOfRangeException","./CollectionBase","../../extends"],e)}(function(e,t){"use strict";function i(e,t){if(e<0)throw new y.ArgumentOutOfRangeException(t,e,"Must be greater than zero");return!0}function r(e,t){return s.Integer.assert(e,t),i(e,t)}Object.defineProperty(t,"__esModule",{value:!0});var n=e("../Compare"),a=e("./Array/Utility"),o=e("../Types"),s=e("../Integer"),u=e("./Enumeration/EnumeratorBase"),p=e("../Exceptions/NotImplementedException"),c=e("../Exceptions/InvalidOperationException"),y=e("../Exceptions/ArgumentOutOfRangeException"),l=e("./CollectionBase"),_=e("../../extends"),f=_["default"],h=void 0,d=4,m=32,v=100,E=d,x=Object.freeze([]),g=function(e){function t(t,i){void 0===i&&(i=n.areEqual);var s=e.call(this,h,i)||this;if(s._head=0,s._tail=0,s._size=0,t)if(o.Type.isNumber(t)){var u=t;r(u,"capacity"),s._array=u?a.initialize(u):x}else{var p=t;s._array=a.initialize(o.Type.isArrayLike(p)?p.length:E),s._importEntries(p)}else s._array=x;return s._capacity=s._array.length,s}return f(t,e),t.prototype.getCount=function(){return this._size},t.prototype._addInternal=function(e){var t=this,i=t._size,r=t._capacity;if(i==r){var n=r*v;n<r+d&&(n=r+d),t.setCapacity(n),r=t._capacity}var a=t._tail;return t._array[a]=e,t._tail=(a+1)%r,t._size=i+1,!0},t.prototype._removeInternal=function(e,t){throw new p.NotImplementedException("ICollection<T>.remove is not implemented in Queue<T> since it would require destroying the underlying array to remove the item.")},t.prototype._clearInternal=function(){var e=this,t=e._array,i=e._head,r=e._tail,n=e._size;return i<r?a.clear(t,i,r):(a.clear(t,i),a.clear(t,0,r)),e._head=0,e._tail=0,e._size=0,e.trimExcess(),n},t.prototype._onDispose=function(){e.prototype._onDispose.call(this),this._array!=x&&(this._array.length=this._capacity=0,this._array=x)},t.prototype.dump=function(e){void 0===e&&(e=1/0);var t=this,i=[];if(isFinite(e)){if(s.Integer.assertZeroOrGreater(e),0!==e)for(;e--&&t._tryDequeueInternal(function(e){i.push(e)}););}else for(;t._tryDequeueInternal(function(e){i.push(e)}););return t.trimExcess(),t._signalModification(),i},t.prototype.forEach=function(t){return e.prototype.forEach.call(this,t,!0)},t.prototype.setCapacity=function(e){var t=this;r(e,"capacity");var i=t._array,n=t._capacity;if(e>n&&t.throwIfDisposed(),e==n)return this;var o=t._head,s=t._tail,u=t._size;if(i!=x&&e>n&&o<s)return i.length=t._capacity=e,t._version++,this;var p=a.initialize(e);return u>0&&(o<s?a.copyTo(i,p,o,0,u):(a.copyTo(i,p,o,0,n-o),a.copyTo(i,p,0,n-o,s))),t._array=p,t._capacity=e,t._head=0,t._tail=u==e?0:u,t._signalModification(!0),this},t.prototype.enqueue=function(e){return this.add(e)},t.prototype._tryDequeueInternal=function(e){if(!this._size)return!1;var t=this._array,i=this._head,r=this._array[i];return t[i]=null,this._head=(i+1)%this._capacity,this._size--,this._incrementModified(),e(r),!0},t.prototype.dequeue=function(e){void 0===e&&(e=!1);var t=this;t.assertModifiable();var i=h;if(!this.tryDequeue(function(e){i=e})&&e)throw new c.InvalidOperationException("Cannot dequeue an empty queue.");return i},t.prototype.tryDequeue=function(e){var t=this;return!!t._size&&(t.assertModifiable(),!!this._tryDequeueInternal(e)&&(t._size<t._capacity/2&&t.trimExcess(m),t._signalModification(),!0))},t.prototype._getElement=function(e){r(e,"index");var t=this;return t._array[(t._head+e)%t._capacity]},t.prototype.peek=function(e){if(void 0===e&&(e=!1),0==this._size){if(e)throw new c.InvalidOperationException("Cannot call peek on an empty queue.");return h}return this._array[this._head]},t.prototype.trimExcess=function(e){var t=this,i=t._size;i<Math.floor(.9*t._capacity)&&(!e&&0!==e||isNaN(e)||e<i)&&t.setCapacity(i)},t.prototype.getEnumerator=function(){var e=this;e.throwIfDisposed();var t,i,r;return new u.EnumeratorBase(function(){i=e._version,r=e._size,t=0},function(n){return e.throwIfDisposed(),e.assertVersion(i),t==r?n.yieldBreak():n.yieldReturn(e._getElement(t++))})},t}(l.CollectionBase);t.Queue=g,t["default"]=g});
//# sourceMappingURL=Queue.js.map